---

- name: Create app namespace on kubernetes cluster.
  command: kubectl --kubeconfig {{ kubernetes_cluster_path_kubeconfig }} apply -f {{ kubernetes_app_tmp_dir }}/1_namespace.yaml
  register: create_namespace_action
  changed_when:
  - "'unchanged' not in create_namespace_action.stdout"

- name: Create app cert on kubernetes cluster.
  command: kubectl --kubeconfig {{ kubernetes_cluster_path_kubeconfig }} apply -f {{ kubernetes_app_tmp_dir }}/2_certs.yaml
  register: create_cert_action
  changed_when:
  - "'unchanged' not in create_cert_action.stdout"
  when:
  - "kubernetes_app_fqdn != ''"
  - "kubernetes_app_certificate_issuer != ''"

- name: Create app pvc on kubernetes cluster.
  command: kubectl --kubeconfig {{ kubernetes_cluster_path_kubeconfig }} apply -f {{ kubernetes_app_tmp_dir }}/3_pvc-{{ volume.name }}.yaml
  register: create_pvc_action
  with_items: "{{ kubernetes_app_volumes }}"
  loop_control:
    loop_var: volume
  changed_when:
  - "'unchanged' not in create_pvc_action.stdout"

- name: Create app deployment on kubernetes cluster.
  command: kubectl --kubeconfig {{ kubernetes_cluster_path_kubeconfig }} apply -f {{ kubernetes_app_tmp_dir }}/4_deployment.yaml
  register: create_deployment_action
  changed_when:
  - "'unchanged' not in create_deployment_action.stdout"

- name: Create app service on kubernetes cluster.
  command: kubectl --kubeconfig {{ kubernetes_cluster_path_kubeconfig }} apply -f {{ kubernetes_app_tmp_dir }}/5_service.yaml
  register: create_service_action
  changed_when:
  - "'unchanged' not in create_service_action.stdout"

- name: Create app ingress on kubernetes cluster.
  command: kubectl --kubeconfig {{ kubernetes_cluster_path_kubeconfig }} apply -f {{ kubernetes_app_tmp_dir }}/6_ingress.yaml
  register: create_ingress_action
  changed_when:
  - "'unchanged' not in create_ingress_action.stdout"
  when: "kubernetes_app_fqdn != ''"

- name: Wait for app to become ready.
  command: kubectl --kubeconfig {{ kubernetes_cluster_path_kubeconfig }} get po -n {{ kubernetes_app_namespace }}
  register: check_app_are_ready_action
  retries: 100
  delay: 5
  until:
  - "'Pending' not in check_app_are_ready_action.stdout"
  - "'ContainerCreating' not in check_app_are_ready_action.stdout"
  - "'ImagePullBackOff' not in check_app_are_ready_action.stdout"
  - "'CrashLoopBackOff' not in check_app_are_ready_action.stdout"
  - "'Error' not in check_app_are_ready_action.stdout"
  - "'ErrImagePull' not in check_app_are_ready_action.stdout"
  - "'Terminating' not in check_app_are_ready_action.stdout"
  changed_when: false

...
